Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34921)
@@ -291,4 +1851,5 @@
             return $val;
         },
+        PrintConvColumns => 2,
         PrintConv => {
             '0 0 0 2' => 'JPEG',
@@ -297,14 +1858,21 @@
             '3 0 0 0' => 'ARW 2.0',
             '3 1 0 0' => 'ARW 2.1',
-            '3 2 0 0' => 'ARW 2.2', # (NEX-5)
+            '3 2 0 0' => 'ARW 2.2', #PH (NEX-5)
+            '3 3 0 0' => 'ARW 2.3', #PH (SLT-A65,SLT-A77)
+            '3 3 1 0' => 'ARW 2.3.1', #PH/JR (DSC-RX1R/RX100M2/Stellar2)
+            '3 3 2 0' => 'ARW 2.3.2', #JR (DSC-RX1RM2,ILCE-7SM2 - support for uncompressed 14-bit RAW)
+            '3 3 3 0' => 'ARW 2.3.3', #JR (ILCE-9)
+            '3 3 5 0' => 'ARW 2.3.5', #JR (DSC-HX99)
+            '4 0 0 0' => 'ARW 4.0', # (ILCE-7SM3)
             # what about cRAW images?
         },
     },
     0xb001 => { # ref http://forums.dpreview.com/forums/read.asp?forum=1037&message=33609644
-        # (ARW and SR2 images only)
+        # (ARW and SR2 images only until the SLT-A65V started writing them to JPEG too)
         Name => 'SonyModelID',
         Writable => 'int16u',
         PrintConvColumns => 2,
         PrintConv => {
+            #0 => 'DSC-HX80', #PH  (and several other DSC models)
             2 => 'DSC-R1',
             256 => 'DSLR-A100',
@@ -314,4 +1882,5 @@
             260 => 'DSLR-A350',
             261 => 'DSLR-A300',
+            262 => 'DSLR-A900 (APS-C mode)', #https://exiftool.org/forum/index.php/topic,3994.0.html
             263 => 'DSLR-A380/A390', #PH (A390)
             264 => 'DSLR-A330',
@@ -319,25 +1888,118 @@
             266 => 'DSLR-A290', #PH
             269 => 'DSLR-A850',
+            270 => 'DSLR-A850 (APS-C mode)', #https://exiftool.org/forum/index.php/topic,3994.0.html
             273 => 'DSLR-A550',
             274 => 'DSLR-A500', #PH
-            275 => 'DSLR-A450', # (http://dev.exiv2.org/issues/show/0000611)
+            275 => 'DSLR-A450', #http://dev.exiv2.org/issues/show/0000611
             278 => 'NEX-5', #PH
             279 => 'NEX-3', #PH
             280 => 'SLT-A33', #PH
-            281 => 'SLT-A55V', #PH
+            281 => 'SLT-A55 / SLT-A55V', #PH (A55 NC)
             282 => 'DSLR-A560', #PH
-            283 => 'DSLR-A580', # (http://u88.n24.queensu.ca/exiftool/forum/index.php/topic,2881.0.html)
+            283 => 'DSLR-A580', #https://exiftool.org/forum/index.php/topic,2881.0.html
+            284 => 'NEX-C3', #PH
+            285 => 'SLT-A35', #JR
+            286 => 'SLT-A65 / SLT-A65V', #PH
+            287 => 'SLT-A77 / SLT-A77V', #PH
+            288 => 'NEX-5N', #PH
+            289 => 'NEX-7', #PH (also Hasselblad Lunar, ref JR)
+            290 => 'NEX-VG20E', #JR
+            291 => 'SLT-A37', #JR
+            292 => 'SLT-A57', #JR
+            293 => 'NEX-F3', #PH
+            294 => 'SLT-A99 / SLT-A99V', #JR (also Hasselblad HV)
+            295 => 'NEX-6', #JR
+            296 => 'NEX-5R', #JR
+            297 => 'DSC-RX100', #PH (also Hasselblad Stellar, ref JR)
+            298 => 'DSC-RX1', #JR
+            299 => 'NEX-VG900', #JR
+            300 => 'NEX-VG30E', #JR
+            302 => 'ILCE-3000 / ILCE-3500', #JR
+            303 => 'SLT-A58', #JR
+            305 => 'NEX-3N', #PH
+            306 => 'ILCE-7', #JR
+            307 => 'NEX-5T', #JR
+            308 => 'DSC-RX100M2', #JR
+            309 => 'DSC-RX10', #JR
+            310 => 'DSC-RX1R', #JR
+            311 => 'ILCE-7R', #JR
+            312 => 'ILCE-6000', #JR
+            313 => 'ILCE-5000', #JR
+            317 => 'DSC-RX100M3', #JR
+            318 => 'ILCE-7S', #JR
+            319 => 'ILCA-77M2', #IB
+            339 => 'ILCE-5100', #JR
+            340 => 'ILCE-7M2', #JR
+            341 => 'DSC-RX100M4', #PH
+            342 => 'DSC-RX10M2', #JR
+            344 => 'DSC-RX1RM2', #JR
+            346 => 'ILCE-QX1', #IB
+            347 => 'ILCE-7RM2', #JR
+            350 => 'ILCE-7SM2', #JR
+            353 => 'ILCA-68', #IB
+            354 => 'ILCA-99M2', #JR
+            355 => 'DSC-RX10M3', #PH
+            356 => 'DSC-RX100M5', #IB/JR
+            357 => 'ILCE-6300', #IB
+            358 => 'ILCE-9', #JR
+            360 => 'ILCE-6500', #JR
+            362 => 'ILCE-7RM3', #IB
+            363 => 'ILCE-7M3', #JR/IB
+            364 => 'DSC-RX0', #PH
+            365 => 'DSC-RX10M4', #JR
+            366 => 'DSC-RX100M6', #IB
+            367 => 'DSC-HX99', #IB
+            369 => 'DSC-RX100M5A', #JR
+            371 => 'ILCE-6400', #IB
+            372 => 'DSC-RX0M2', #JR
+            374 => 'DSC-RX100M7', #IB
+            375 => 'ILCE-7RM4', #IB
+            376 => 'ILCE-9M2', #JR
+            378 => 'ILCE-6600', #IB/JR
+            379 => 'ILCE-6100', #IB/JR
+            380 => 'ZV-1', #JR
+            381 => 'ILCE-7C', #JR
+            383 => 'ILCE-7SM3',
+            384 => 'ILCE-1', #PH
         },
     },
     0xb020 => { #2
-        Name => 'ColorReproduction',
-        # observed values: None, Standard, Vivid, Real, AdobeRGB - PH
+        Name => 'CreativeStyle', # (called CreativeLook by the 7SM3, ref JR)
         Writable => 'string',
+        # (all of these values have been observed, ref JR and PH)
+        # - this PrintConv is included to make these strings consistent with
+        #   other CreativeStyle tags, and to facilitate the language translations
+        # - these values are always English, regardless of the camera language settings
+        PrintConv => {
+            OTHER => sub { shift }, # pass other values straight through
+            None        => 'None',
+            AdobeRGB    => 'Adobe RGB',
+            Real        => 'Real',
+            Standard    => 'Standard',
+            Vivid       => 'Vivid',
+            Portrait    => 'Portrait',
+            Landscape   => 'Landscape',
+            Sunset      => 'Sunset',
+            Nightview   => 'Night View/Portrait',
+            BW          => 'B&W',
+            Neutral     => 'Neutral',
+            Clear       => 'Clear',
+            Deep        => 'Deep',
+            Light       => 'Light',
+            Autumnleaves=> 'Autumn Leaves',
+            Sepia       => 'Sepia',
+            # new for the ILCE-7SM3 (ref JR)
+            VV2 => 'Vivid 2',  # (NC)
+            FL => 'FL', # "moody finish with sharp contrast and calm coloring as well as the impressive sky and colors of the greens"
+            IN => 'IN', # "matte textures by suppressing the contrast and saturation"
+            SH => 'SH', # "bright, transparent, soft, and vivid mood"
+            # (...also Custom Look 1-6, but don't konw the values)
+        },
     },
     0xb021 => { #2
         Name => 'ColorTemperature',
         Writable => 'int32u',
-        PrintConv => '$val ? $val : "Auto"',
-        PrintConvInv => '$val=~/Auto/i ? 0 : $val',
+        PrintConv => '$val ? ($val==0xffffffff ? "n/a" : $val) : "Auto"',
+        PrintConvInv => '$val=~/Auto/i ? 0 : ($val eq "n/a" ? 0xffffffff : $val)',
     },
     0xb022 => { #7
@@ -350,4 +2012,5 @@
         Name => 'SceneMode',
         Writable => 'int32u',
+        PrintConvColumns => 2,
         PrintConv => \%Image::ExifTool::Minolta::minoltaSceneMode,
     },
@@ -364,4 +2027,5 @@
         Name => 'DynamicRangeOptimizer',
         Writable => 'int32u',
+        PrintConvColumns => 2,
         PrintConv => {
             0 => 'Off',
@@ -374,5 +2038,5 @@
             11 => 'Advanced Lv4', #JD
             12 => 'Advanced Lv5', #JD
-            16 => 'Lv1', # (NEX_5)
+            16 => 'Lv1', # (NEX-5)
             17 => 'Lv2',
             18 => 'Lv3',
@@ -384,5 +2048,9 @@
         Name => 'ImageStabilization',
         Writable => 'int32u',
-        PrintConv => { 0 => 'Off', 1 => 'On' },
+        PrintConv => {
+            0 => 'Off',
+            1 => 'On',
+            0xffffffff => 'n/a', # (HX9V sweep panorama, ref JR)
+        },
     },
     0xb027 => { #2
@@ -390,4 +2058,6 @@
         Writable => 'int32u',
         SeparateTable => 1,
+        # set to 65535 for E-mount lenses (values 0x80xx)
+        ValueConvInv => '($val & 0xff00) == 0x8000 ? 65535 : int($val)',
         PrintConv => \%sonyLensTypes,
     },
@@ -407,5 +2077,20 @@
         Name => 'ColorMode',
         Writable => 'int32u',
+        PrintConvColumns => 2,
         PrintConv => \%Image::ExifTool::Minolta::sonyColorMode,
+    },
+    0xb02a => {
+        Name => 'LensSpec',
+        Format => 'undef',
+        Writable => 'int8u',
+        Count => 8,
+        Notes => q{
+            like LensInfo, but also specifies lens features: DT, E, ZA, G, SSM, SAM,
+            OSS, STF, Reflex, Macro and Fisheye
+        },
+        ValueConv => \&ConvLensSpec,
+        ValueConvInv => \&ConvInvLensSpec,
+        PrintConv => \&PrintLensSpec,
+        PrintConvInv => \&PrintInvLensSpec,
     },
     0xb02b => { #PH (A550 JPEG and A200, A230, A300, A350, A380, A700 and A900 ARW)
@@ -443,29 +2128,38 @@
         Writable => 'int16u',
         RawConv => '$val == 65535 ? undef : $val',
-        PrintConv => {
-            0 => 'Auto',
+        PrintConvColumns => 2,
+        PrintConv => {
+            0 => 'Program AE', # (RX100 'Program','Sunset' - PH)
             1 => 'Portrait', #PH (HX1)
             2 => 'Beach', #9
+            3 => 'Sports', #9
             4 => 'Snow', #9
             5 => 'Landscape',
-            6 => 'Program',
-            7 => 'Aperture Priority',
-            8 => 'Shutter Priority',
+            6 => 'Auto', # (RX100 'Intelligent Auto' - PH)
+            7 => 'Aperture-priority AE',
+            8 => 'Shutter speed priority AE',
             9 => 'Night Scene / Twilight',#2/9
             10 => 'Hi-Speed Shutter', #9
-            11 => 'Twilight Portrait', #9
-            12 => 'Soft Snap', #9
+            11 => 'Twilight Portrait', #9 (RX100 'Night Portrait' - PH)
+            12 => 'Soft Snap/Portrait', #9 (TX7 'Soft Snap'; RX100/A37 'Portrait' but manuals say "reproduces soft skin tone" - PH)
             13 => 'Fireworks', #9
             14 => 'Smile Shutter', #9 (T200)
             15 => 'Manual',
             18 => 'High Sensitivity', #9
+            19 => 'Macro', #JR
             20 => 'Advanced Sports Shooting', #9
             29 => 'Underwater', #9
-            33 => 'Gourmet', #9
-            34 => 'Panorama', #PH (HX1)
-            35 => 'Handheld Twilight', #PH (HX1/TX1)
+            # 30 seen for DSC-W110 and W390, maybe something with Face or Portrait ??
+            33 => 'Food', #9
+            34 => 'Sweep Panorama', #PH (HX1)
+            35 => 'Handheld Night Shot', #PH (HX1/TX1, also called "Hand-held Twilight")
             36 => 'Anti Motion Blur', #PH (TX1)
             37 => 'Pet', #9
             38 => 'Backlight Correction HDR', #9
+            39 => 'Superior Auto', #9
+            40 => 'Background Defocus', #PH (HX20V)
+            41 => 'Soft Skin', #JR (HX9V) (HX200V Portrait - PH)
+            42 => '3D Image', #JR (HX9V)
+            # 50 seen for DSC-W530
             65535 => 'n/a', #PH (A100)
         },
@@ -473,29 +2167,59 @@
     0xb042 => { #9
         Name => 'FocusMode',
+        # Only FocusMode for older DSC models;
+        # Newest DSC models give only 0, many models of 'HX9V generation' give only 4 -
+        # these models give FocusMode in tag 0xb04e, and are excluded here.
+        Condition => q{
+            ($$self{TagB042} = Get16u($valPt, 0)) and
+            (not $$self{MetaVersion} or $$self{MetaVersion} ne 'DC7303320222000')
+        },
+        Notes => 'not valid for all models',
         Writable => 'int16u',
         RawConv => '$val == 65535 ? undef : $val',
         PrintConv => {
+            # 0 - seen this for panorama shot
             1 => 'AF-S', # (called Single-AF by Sony)
             2 => 'AF-C', # (called Monitor-AF by Sony)
-            4 => 'Permanent-AF', # (TX7)
+            4 => 'Permanent-AF', # (TX7,HX9V?)
+            65535 => 'n/a', #PH (A100), also for DSC-W690 panorama shots
+        },
+    },
+    0xb043 => [{ #9
+        Name => 'AFAreaMode',
+        # AFAreaMode only for older models;
+        # exclude newest DSC models, which give AFAreaMode in Tag9402 0x0017 (eg. RX100 - PH)
+        Writable => 'int16u',
+        Condition => 'not $$self{MetaVersion} or $$self{MetaVersion} ne "DC7303320222000"', #JR
+        RawConv => '$val == 65535 ? undef : $val',
+        Notes => 'older models',
+        PrintConv => {
+            # 0 - (takes this value after camera reset, but can't be set back once changed)
+            0 => 'Default',
+            1 => 'Multi',
+            2 => 'Center',
+            3 => 'Spot',
+            4 => 'Flexible Spot', # (T200)
+            6 => 'Touch',
+            14 => 'Tracking', #JR (HX9V) ("Manual" for the T200?, ref 9)
+            15 => 'Face Tracking', # (not set when in face detect mode and no faces detected)
             65535 => 'n/a', #PH (A100)
         },
-    },
-    0xb043 => { #9
-        Name => 'AFMode',
+    },{ #JR
+        Name => 'AFAreaMode',
+        # AFAreaMode for DSC-HX9V generation, having values that appear to be different from older models.
         Writable => 'int16u',
-        RawConv => '$val == 65535 ? undef : $val',
-        PrintConv => {
-            0 => 'Default', # (takes this value after camera reset, but can't be set back once changed)
-            1 => 'Multi AF',
-            2 => 'Center AF',
-            3 => 'Spot AF',
-            4 => 'Flexible Spot AF', # (T200)
-            6 => 'Touch AF',
-            14 => 'Manual Focus', # (T200)
-            15 => 'Face Detected', # (not set when in face detect mode and no faces detected)
-            65535 => 'n/a', #PH (A100)
-        },
-    },
+        Condition => '$$self{TagB042} and $$self{TagB042} != 0',
+        Notes => 'DSC-HX9V generation cameras',
+        PrintConv => {
+            0 => 'Multi',
+            1 => 'Center',
+            2 => 'Spot', #(NC) seen for DSC-WX9
+            3 => 'Flexible Spot',
+            10 => 'Selective (for Miniature effect)', # seen for Miniature effect of DSC-WX30
+            14 => 'Tracking',
+            15 => 'Face Tracking',
+            255 => 'Manual',
+        },
+    }],
     0xb044 => { #9
         Name => 'AFIlluminator',
@@ -508,22 +2232,39 @@
         },
     },
+    # 0xb045 - int16u: 0
+    # 0xb046 - int16u: 0
     0xb047 => { #2
-        Name => 'Quality',
+        Name => 'JPEGQuality',
         Writable => 'int16u',
         RawConv => '$val == 65535 ? undef : $val',
         PrintConv => {
+            0 => 'Standard',
+            1 => 'Fine',
+            2 => 'Extra Fine', #JR
+            65535 => 'n/a', #PH (A100)
+        },
+    },
+    0xb048 => { #9
+        Name => 'FlashLevel',  #JR other name, but values -9 to 9 match FlashExposureCompensation
+        Writable => 'int16s',
+        RawConv => '($val == -1 and $$self{Model} =~ /DSLR-A100\b/) ? undef : $val',
+        PrintConv => {
+            -32768 => 'Low',
+            -9 => '-9/3', #JR
+            -6 => '-6/3', #JR
+            -5 => '-5/3', #JR
+            -4 => '-4/3', #JR
+            -3 => '-3/3',
+            -2 => '-2/3',
+            -1 => '-1/3', # (for the A100, -1 is effectively 'n/a' - PH)
             0 => 'Normal',
-            1 => 'Fine',
-            65535 => 'n/a', #PH (A100)
-        },
-    },
-    0xb048 => { #9
-        Name => 'FlashLevel',
-        Writable => 'int16s',
-        RawConv => '$val == -1 ? undef : $val',
-        PrintConv => {
-            -32768 => 'Low',
-            -1 => 'n/a', #PH (A100)
-            0 => 'Normal',
+            1 => '+1/3',
+            2 => '+2/3',
+            3 => '+3/3',
+            4 => '+4/3', #JR (NC)
+            5 => '+5/3', #JR (NC)
+            6 => '+6/3', #JR
+            9 => '+9/3', #JR
+            128 => 'n/a', #JR (HX9V)
             32767 => 'High',
         },
@@ -534,8 +2275,9 @@
         RawConv => '$val == 65535 ? undef : $val',
         PrintConv => {
-            0 => 'Normal',
-            2 => 'Burst',
+            0 => 'Normal', # (ie. shutter button)
+            2 => 'Continuous',
             5 => 'Exposure Bracketing',
             6 => 'White Balance Bracketing', # (HX5)
+            8 => 'DRO Bracketing', #JR (ILCE-7RM2)
             65535 => 'n/a', #PH (A100)
         },
@@ -563,12 +2305,33 @@
         },
     },
-    0xb04e => { #2
-        Name => 'LongExposureNoiseReduction',
+    # 0xb04c - rational64u: 10/10 (seen 5 for HX9V Manual-exposure images, ref JR)
+    # 0xb04d - int16u: 0
+    # (the Kamisaka decoding of 0xb04e seems wrong - ref JR)
+    # 0xb04e => { #2
+    #     Name => 'LongExposureNoiseReduction',
+    #     Notes => 'LongExposureNoiseReduction for other models',
+    #     Writable => 'int16u',
+    #     RawConv => '$val == 65535 ? undef : $val',
+    #     PrintConv => {
+    #         0 => 'Off',
+    #         1 => 'On',
+    #         2 => 'On 2', #PH (TX10, TX100, WX9, WX10, etc)
+    #         # 4 - seen this (CX360E, CX700E)
+    #         65535 => 'n/a', #PH (A100)
+    #     },
+    # },
+    0xb04e => { #PH (RX100) - but not in RX100M3 anymore (ref JR)
+        Name => 'FocusMode',
+        Condition => '$$self{MetaVersion} and $$self{MetaVersion} eq "DC7303320222000"', #JR
+        Notes => 'valid for DSC-HX9V generation and newer',
         Writable => 'int16u',
-        RawConv => '$val == 65535 ? undef : $val',
-        PrintConv => {
-            0 => 'Off',
-            1 => 'On',
-            65535 => 'n/a', #PH (A100)
+        PrintConv => {
+            0 => 'Manual',
+            # 1 - seen for DSC-WX7 burst, HDR-CX130E/CX560E
+            2 => 'AF-S',
+            3 => 'AF-C',
+            # 4 - seen for HDR-CX360E/CX700E
+            5 => 'Semi-manual', #JR (HX9V)
+            6 => 'DMF', # "Direct Manual Focus"
         },
     },
@@ -576,10 +2339,27 @@
         Name => 'DynamicRangeOptimizer',
         Writable => 'int16u',
+        Priority => 0, # (unreliable for the A77)
         PrintConv => {
             0 => 'Off',
             1 => 'Standard',
             2 => 'Plus',
-        },
-    },
+            # 8 for HDR models - what does this mean?
+        },
+    },
+    0xb050 => { #PH (RX100)
+        Name => 'HighISONoiseReduction2',
+        Condition => '$$self{Model} =~ /^(DSC-|Stellar)/',
+        Notes => 'DSC models only',
+        Writable => 'int16u',
+        PrintConv => {
+            0 => 'Normal',
+            1 => 'High',
+            2 => 'Low',
+            3 => 'Off', #JR
+            # it seems that all SLT and NEX models give n/a here (ref JR)
+            65535 => 'n/a',
+        },
+    },
+    # 0xb051 - int16u: 0
     0xb052 => { #PH (TX1)
         Name => 'IntelligentAuto',
@@ -591,20 +2371,29 @@
         },
     },
-    0xb054 => { #PH (TX1)
+    # 0xb053 - int16u: normally 0, but got 1 for a superior auto backlight picture (RX100)
+    0xb054 => { #PH/9/JR (TX1,TX7,RX100,HX9V)
         Name => 'WhiteBalance',
         Writable => 'int16u',
-        Priority => 0, # (until more values are filled in)
+        Notes => q{
+            decoding of the Fluorescent settings matches the EXIF standard, which is
+            different than the names used by Sony for some models
+        },
         PrintConv => {
             0 => 'Auto',
-            4 => 'Manual',
+            4 => 'Custom', # (manual)
             5 => 'Daylight',
-            6 => 'Cloudy', #9
-            7 => 'White Flourescent', #9      (Sony "Fluorescent 1 (White)")
-            8 => 'Cool White Flourescent', #9 (Sony "Fluorescent 2 (Natural White)")
-            9 => 'Day White Flourescent', #9  (Sony "Fluorescent 3 (Day White)")
+            6 => 'Cloudy',
+            # PrintConv names matching Exif Fluorescent LightSource names (ref JR)
+            # (Sony uses conflicting names for some models)
+            7 => 'Cool White Fluorescent', # (RX100) (TX7/HX9V "Fluorescent 1 (White)", ref 9/JR)
+            8 => 'Day White Fluorescent',  # (RX100) (TX7/HX9V "Fluorescent 2 (Natural White)", ref 9/JR)
+            9 => 'Daylight Fluorescent',   # (RX100) (TX7/HX9V "Fluorescent 3 (Day White)", ref 9/JR)
+            10 => 'Incandescent2', #JR (HX9V)
+            11 => 'Warm White Fluorescent',
             14 => 'Incandescent',
-            15 => 'Flash', #9
+            15 => 'Flash',
             17 => 'Underwater 1 (Blue Water)', #9
             18 => 'Underwater 2 (Green Water)', #9
+            19 => 'Underwater Auto', #JR
         },
     },
@@ -629,4 +2418,5 @@
         DataTag => 'PreviewImage',
         Writable => 'int32u',
+        WriteGroup => 'MakerNotes',
         Protected => 2,
         Notes => 'a small 320x200 preview image',
@@ -637,40 +2427,32 @@
         DataTag => 'PreviewImage',
         Writable => 'int32u',
+        WriteGroup => 'MakerNotes',
         Protected => 2,
     },
 );
 
-# Camera settings (ref PH) (decoded mainly from A200)
-%Image::ExifTool::Sony::CameraSettings = (
+# camera information for the A700/A850/A900 (ref JR)
+%Image::ExifTool::Sony::CameraInfo = (
     %binaryDataAttrs,
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
-    FORMAT => 'int16u',
-    NOTES => q{
-        Camera settings for the A200, A230, A300, A350, A700, A850 and A900.  Some
-        tags are only valid for certain models.
-    },
-    0x04 => { #7 (A700, not valid for other models)
-        Name => 'DriveMode',
-        Condition => '$$self{Model} =~ /DSLR-A700\b/',
-        Notes => 'A700 only',
-        PrintConv => {
-            1 => 'Single Frame',
-            2 => 'Continuous High',
-            4 => 'Self-timer 10 sec',
-            5 => 'Self-timer 2 sec',
-            7 => 'Continuous Bracketing',
-            12 => 'Continuous Low',
-            18 => 'White Balance Bracketing Low',
-            19 => 'D-Range Optimizer Bracketing Low',
-        },
-    },
-    0x06 => { #7 (A700, not valid for other models)
-        Name => 'WhiteBalanceFineTune',
-        Condition => '$$self{Model} =~ /DSLR-A700\b/',
-        Format => 'int16s',
-        Notes => 'A700 only',
-    },
-    0x10 => { #7 (A700, not confirmed for other models)
-        Name => 'FocusMode',
+    NOTES => 'Camera information for the A700, A850 and A900.',
+    0x00 => {
+        Name => 'LensSpec',
+        # the A700/A850/A900 use a different int16 byte ordering! - PH
+        Format => 'undef[8]',
+        ValueConv => sub {
+            my $val = shift;;
+            return ConvLensSpec(pack('v*', unpack('n*', $val)));
+        },
+        ValueConvInv => sub {
+            my $val = shift;
+            return pack('v*', unpack('n*', ConvInvLensSpec($val)));
+        },
+        PrintConv => \&PrintLensSpec,
+        PrintConvInv => \&PrintInvLensSpec,
+    },
+    0x0014 => {
+        Name => 'FocusModeSetting',
+        Notes => 'FocusModeSetting for the A700, A850 and A900',
         PrintConv => {
             0 => 'Manual',
